Attribute VB_Name = "modShellExecute"
'
'  MODULE : modShellExecute.bas
'  AUTHOR : Joseph Cox, AKA BootBlock.
'  WEBSITE: http://www.tnk-bootblock.co.uk
'
Private Declare Function ShellExecuteEx Lib "shell32.dll" Alias "ShellExecuteExA" (lpExecInfo As SHELLEXECUTEINFO) As Long

Enum enumWindowState
  ShowHide = 0
  ShowNormal = 1
  ShowMinimised = 2
  ShowMaximised = 3
  ShowNoActivate = 4
  Restore = 9
  ShowDefault = 10
End Enum

' Used with ShellExecuteEx
Private Const SEE_MASK_NOCLOSEPROCESS = &H40
Private Const SEE_MASK_FLAG_NO_UI = &H400      ' Supresses Windows err msgs.

' Used in ShellExecuteEx
Public Type SHELLEXECUTEINFO
  cbSize As Long
  fMask As Long
  hWnd As Long
  lpVerb As String
  lpFile As String
  lpParameters As String
  lpDirectory As String
  nShow As Long
  hInstApp As Long
  lpIDList As Long
  lpClass As String
  hkeyClass As Long
  dwHotKey As Long
  hIcon As Long
  hProcess As Long
End Type

Public Sub ShellExe(sFilename As String, Optional sPars As String = "", Optional lhWnd As Long = 0, Optional winWindowState As enumWindowState = ShowNormal)
 On Error Resume Next
  Dim sei As SHELLEXECUTEINFO   ' structure used by the function
  Dim retval As Long            ' return value

  ' The other elements of the structure are either not used
  ' or will be set when the function returns.
  With sei
    .cbSize = Len(sei)                ' Size of the structure
    .fMask = SEE_MASK_NOCLOSEPROCESS  ' Use the optional hProcess element of the structure.
    .hWnd = lhWnd                     ' Handle to the window calling this function.
    .lpVerb = "open"                  ' The action to perform: open the file.
    .lpFile = sFilename               ' The file to open.
    .lpParameters = sPars             ' No additional parameters are needed here.
    'If sDefaultDirectory <> "" Then .lpDirectory = sDefaultDirectory
    .nShow = winWindowState           ' Simply display the window.
  End With

  ' Open the file using its associated program.
  retval = ShellExecuteEx(sei)

  If retval = 0 Then
    Select Case sei.hInstApp
      Case Else: MsgBox "An unexpected error occured:" & vbCrLf & "    Maybe file doesn't exist?", vbCritical + vbOKOnly, "ShellExe()"
    End Select
  End If
End Sub

